import os
import re
import sys
from time import strftime
from tkinter import messagebox, ttk
from tkinter import *
import tkinter as tk
from shutil import copytree
import shutil
from threading import Event
import threading
from multiprocessing import Process
from tkinter.messagebox import askyesno
import time
import pyudev







#----------------------------------------------------------------------------------------
# Se definen variables necesarias
#----------------------------------------------------------------------------------------
global exit
exit = Event()
idioma="Español"
stop_temp=True
user=os.popen("whoami").read()
permitir_copia=True

#----------------------------------------------------------------------------------------
# Variables para los mensajes en Español
#----------------------------------------------------------------------------------------

seleccionarPrimeroOrigen="Debe seleccionar primero el origen"
usadoEn="Usado en "
libre=" Libre: "
Error="Error"
noHayOrigen="No hay ningun origen seleccionado"
noHayDestino="No hay ningun destino seleccionado"
cancelado="Cancelado"
seHaCancelado="Se ha detenido el Backup"
noHayEspacio="No hay espacio suficiente en el destino"
noHayDCIM="No existe DCIM en el origen"
mismoOrigenDestino="El origen y el destino no pueden ser el mismo"
esperaCopia="Espera a que termine la primera copia"
haIdoMal="Algo ha ido mal con el backup"
noDispositivo="No hay dispositivo"
expulsado="El dispositivo se ha expulsado"
reiniciarTitle="Reiniciar"
reiniciar="Está seguro que quiere reiniciar?"
apagarTitle="Apagar"
apagar="¿Está seguro que quiere apagar?"
backupRealizado="Se ha realizado el backup"
hecho="Hecho"




#----------------------------------------------------------------------------------------
#---------------- SE DEFINEN LAS FUNCIONES ----------------------------------------------
#----------------------------------------------------------------------------------------

#----------------------------------------------------------------------------------------
#Método para obtener una lista de los dispositivos de almacenamiento usb montados
#----------------------------------------------------------------------------------------

def get_lista():    
    global lista
    peticion="/media/"+str(user).rstrip("\n")+"/"
    lista = os.listdir(peticion)
    return lista

get_lista()


#----------------------------------------------------------------------------------------
#Método para seleccionar una copia desde la carpeta DCIM o desde la raíz del dispositivo
# haciendo así una copia directa de todo el contenido de este
#----------------------------------------------------------------------------------------
def seleccion_tipo_copia(event):
    
    try:
        global src
        if combo_copia.get()=="DCIM":
           
            #print(str(user))
            src = "/media/"+str(user).rstrip("\n")+"/"+origen+"/DCIM"
            return src
        
        else:
            
            src="/media/"+str(user).rstrip("\n")+"/"+origen
            return src
        #print(src)
    except:
        
        messagebox.showinfo(title=Error, message=seleccionarPrimeroOrigen)
        



#----------------------------------------------------------------------------------------
#Método de seleccion de origen (p.e. tarjeta SD)
#----------------------------------------------------------------------------------------
def seleccion_origen(event):
    global origen
    origen = combo_origen.get()
    seleccion_tipo_copia(event)
    #print(src)
    try:
        totalOrigen, usadoOrigen, disponibleOrigen = shutil.disk_usage(src)
        if (usadoOrigen // (10**9))<=1:
            usoOrigen= str(usadoOrigen // (10**6)) + "MB"
        else:
            usoOrigen=str(usadoOrigen // (10**9))+"GB"
            
        if (disponibleOrigen // (10**9))<=1:
            dispOrigen= str(disponibleOrigen // (10**6)) + "MB"
        else:
            dispOrigen=str(disponibleOrigen // (10**9)) + "GB"
        
        
        #estado = usadoEn + combo_copia.get()+" : "+(usoOrigen) + libre + (dispOrigen)
        #estadoOrigen.config(text=estado)
        cambiar_estado_origen(usoOrigen, dispOrigen)
        
    except:
        estadoOrigen.config(text=noHayDCIM)
        
def cambiar_estado_origen(usado, disponible):
    estado = usadoEn + combo_copia.get()+" : "+(usado) + libre + (disponible)
    estadoOrigen.config(text=estado)
    

#----------------------------------------------------------------------------------------
# Método de seleccion de destino (p.e. HDD)
#----------------------------------------------------------------------------------------
def seleccion_destino(event):
    global destino
    destino = combo_destino.get()
    user=os.popen("whoami").read()
    #print(user)
    dest = "/media/"+str(user).rstrip("\n")+"/"+destino
    totalDestino, usadoDestino, disponibleDestino = shutil.disk_usage(dest)
    
    if (totalDestino // (10**9))<=1:
        tDestino= str(totalDestino // (10**6)) + "MB"
    else:
        tDestino= str(totalDestino // (10**9))+"GB"
        
    if (disponibleDestino // (10**9))<=1:
        dispDestino= str(disponibleDestino // (10**6)) + "MB"
    else:
        dispDestino= str(disponibleDestino // (10**9)) + "GB"
    
    
    #estado = "Total: " + (tDestino) + libre + (dispDestino)
    #estadoDestino.config(text=estado)
    cambiar_estado_destino(tDestino, dispDestino)
    
    
    

def cambiar_estado_destino(total, disponible):
    estado = "Total: " + (total) + libre + (disponible)
    estadoDestino.config(text=estado)

#----------------------------------------------------------------------------------------
# Método para comprobar si hay origen y destino
#----------------------------------------------------------------------------------------
def comprobar_origen_destino():
    
    try:
        print("El origen es "+origen)
        origen
        
        
    except:
        print("No hay ningun origen seleccionado")
        permitir_copia=True
        messagebox.showinfo( title=noHayOrigen, message=noHayOrigen)
        return False
        
        
        
    try:    
        print("El destino es "+destino)
        destino
        
        
    except:
        print("No hay ningun destino seleccionado")
        messagebox.showinfo( title=noHayDestino, message=noHayDestino)
        return False
       
#----------------------------------------------------------------------------------------        
# Método para realizar la copia 
#----------------------------------------------------------------------------------------
def backup():
    try:
        global permitir_copia
        if permitir_copia==True:
            permitir_copia=False
            if origen!=destino:
                if os.path.exists(src):
                   
                    if espacio_disponible(): 
                        print("\n##########################")
                        ventana_progreso()
                        print("abrimos ventana progreso en Backup()")
                        fecha_hora = strftime("%d_%m_%Y %H_%M_%S")
                        carpetanueva= "/Copia "+ fecha_hora
                        global dst
                        dst = "/media/"+str(user).rstrip("\n")+"/"+ destino + carpetanueva
                        background(calcular_tamanyo)
                        print("background calcular tamaño()")
                        global proc
                        proc = Process(target=cp, args=(src, dst), daemon=True)
                        proc.start() #copytree(src,dst)
                        proc.join()
                        #print(str(src), str(dst))
                        print(proc)
                
                        if proc.exitcode==0:
                            #messagebox.showinfo(title="Hecho", message="Se ha realizado
                            #  el Backup")
                            permitir_copia=True
                            return
                            
                        else:
                            print("El backup se ha cancelado")
                            permitir_copia=True
                            messagebox.showinfo(title=cancelado, message=seHaCancelado)
                            
                            
                    else:
                        permitir_copia=True
                        
                        messagebox.showinfo(title=Error, message=noHayEspacio)
                        
                        
                else:
                    permitir_copia=True
                    
                    messagebox.showinfo(title=Error, message=noHayDCIM)
                    
                        
            else:
                permitir_copia=True
                
                messagebox.showinfo(title=Error, message=mismoOrigenDestino)
                
                
        else:
            
            messagebox.showinfo(title=Error, message=esperaCopia)
           
    except:
        print("algo ha ido mal al copiar")
        permitir_copia=True
        messagebox.showinfo(title=Error, message=haIdoMal)
        



#----------------------------------------------------------------------------------------
# Método callback del botón de realizar la copia
#----------------------------------------------------------------------------------------
def botoncopia():
    
    if comprobar_origen_destino()!=False:
        background(backup)
    
    
#----------------------------------------------------------------------------------------
#Método que actualiza la lista de dispositivos
#----------------------------------------------------------------------------------------
def actualizar_lista():
    listanueva = get_lista()
    combo_origen['value'] = listanueva
    combo_destino['value'] = listanueva
    print("Boton actualizar lista pulsado")


#----------------------------------------------------------------------------------------
#Funciópn que llama a actualizar_lista cada vez que hay concexión o desconexión de
# dispositivos USB
#----------------------------------------------------------------------------------------
def actualizar_lista_auto():
    #import pyudev
    context = pyudev.Context()
    monitor = pyudev.Monitor.from_netlink(context)
    monitor.filter_by(subsystem='usb')

    for device in iter(monitor.poll, None):
        #print('{} connected'.format(device))
        time.sleep(0.5)
        actualizar_lista()
          
 
#----------------------------------------------------------------------------------------
#Método que solicita expulsar el dispositivo seleccionado como origen
#----------------------------------------------------------------------------------------
def comando_expulsar_origen():
    try:
        nombre = "/media/"+str(user).rstrip("\n")+"/" + combo_origen.get()
        expulsar(nombre)
        actualizar_lista()
    except:
        
        messagebox.showinfo(title=Error, message=noDispositivo)
       
    
#----------------------------------------------------------------------------------------
#Método que solicita expulsar el dispositivo seleccionado como destino
#----------------------------------------------------------------------------------------
def comando_expulsar_destino():
    try:
        nombre = "/media/"+str(user).rstrip("\n")+"/" + combo_destino.get()
        expulsar(nombre)
        actualizar_lista()
    except:
        
        messagebox.showinfo(title=Error, message=noDispositivo)
        
    
#----------------------------------------------------------------------------------------
#Método para expulsar dispositivo. Desmonta y apaga el dispositivo
#----------------------------------------------------------------------------------------
def expulsar(nombre):
    if permitir_copia==True:    
        comando_expulsar1 = "sudo udisksctl unmount -b /dev/" + buscar_ruta(nombre)
        comando_expulsar2 = "sudo udisksctl power-off -b /dev/" + buscar_ruta(nombre)
        print(comando_expulsar1)
        print(comando_expulsar2)
        os.system(comando_expulsar1)
        os.system(comando_expulsar2)
        
        
        messagebox.showinfo(title=expulsado, message=expulsado)
    else:
        messagebox.showinfo(title=Error, message=esperaCopia)
        
#----------------------------------------------------------------------------------------
#Método para encontrar la ruta del dispositivo seleccionado
#----------------------------------------------------------------------------------------
def buscar_ruta(nombre):
    
    pattern = r'NAME="(\w*)" SIZE="(\d{0,}.\d{0,}[G|M|K])" TYPE="(\w*)" MOUNTPOINT="(.*)"'
    lsblk = []
    os.system("lsblk -P -o name,size,type,mountpoint > lsblk.out")
    #lsbk = os.system("lsblk -P -o name,size,type,mountponit")
    with open('lsblk.out','r') as reader:
        for line in reader.readlines():
            found = re.search(pattern,line).groups()
            lsblk.append({"name":found[0],"size":found[1],"type":found[2],
            "mountpoint":found[3]})

    #pp(lsblk) #Pretty print the list of dictionaries

    main_device = list(filter(lambda x: x["mountpoint"] == nombre, lsblk))[0]
    print(main_device["name"]) #Print the device name that is mounted to /
    os.remove("lsblk.out")
    return main_device["name"]        

#----------------------------------------------------------------------------------------
#Método para encender o apagar el punto de acceso wifi
#----------------------------------------------------------------------------------------
def wifi():
    input = "sudo systemctl " + var.get() + " hostapd"
    os.system(input)
    print(var.get())

#----------------------------------------------------------------------------------------
#Método que detiene la ejecución de la copia
#----------------------------------------------------------------------------------------
def detener_backup():
    try:
        proc.terminate()
        
        texto.config(text="Se ha cancelado la copia")
        ventanaProgreso.destroy()
        
        messagebox.showinfo(ventanaProgreso, title=cancelado, message=seHaCancelado)
        
    except:
        return

#----------------------------------------------------------------------------------------
#Método para crear un hilo paralelo
#----------------------------------------------------------------------------------------
def background(func):
    global t
    t = threading.Thread(target=func)
    t.start()

#----------------------------------------------------------------------------------------
# Método que utiliza Copytree() para realizar la copia de todos los archivos. 
# Usa el método copy2(), con el cual se copian los metadatos
#----------------------------------------------------------------------------------------
def cp(src: str, dest: str):
    print("cp iniciado")
    #print("Despues de barra")
    
    copytree(src, dest)
    print("cp finalizado")
    
        
#----------------------------------------------------------------------------------------
#Método para volver a cargar la aplicación
#----------------------------------------------------------------------------------------
def reiniciar_app():
    os.execl(sys.executable, sys.executable, *sys.argv)

#----------------------------------------------------------------------------------------
#Método que reinicia el dispositivo
#----------------------------------------------------------------------------------------
def reiniciar_dispositivo():
    
    respuesta = askyesno(title=reiniciarTitle,
                    message=reiniciar)
    
    if respuesta:
        os.system("sudo shutdown -r now")
        print("Reiniciaría el dispositivo")

#----------------------------------------------------------------------------------------
#Método que apaga el dispositivo
#----------------------------------------------------------------------------------------
def apagar_dispositivo():
    
    respuesta = askyesno(title=apagarTitle,
                    message=apagar)
   
    if respuesta:
        os.system("sudo shutdown -h now")
        print("Apagaría el dispositivo")

#----------------------------------------------------------------------------------------
#Método que quita la pantalla completa de la app
#----------------------------------------------------------------------------------------
def minimizar():
    main_window.attributes('-fullscreen', False)
    
#----------------------------------------------------------------------------------------
#Método que crea la ventana que muestra el progreso de la copia
#----------------------------------------------------------------------------------------
def ventana_progreso():
    if idioma=="Español":
        global ventanaProgreso
        ventanaProgreso = Toplevel(main_window)
        ventanaProgreso.title("Copiando")
        ventanaProgreso.geometry(f'{"300"}x{"160"}+{int(90)}+{int(90)}')
        #ventanaProgreso.geometry("300x160")
        ventanaProgreso.minsize(300, 160)
        
        global progressbar2
        progressbar2 = ttk.Progressbar(ventanaProgreso, mode="determinate", length=280)
        progressbar2.grid(row=1, sticky=tk.EW, pady=5, padx=10)
        progressbar2.step(0)
        
        global texto
        texto = Label(ventanaProgreso, text="Se está realizando la copia")
        texto.grid(row=0, sticky=tk.EW, pady=10, padx=25)
        
        global textoporc
        textoporc = Label(ventanaProgreso, text="Copiado: 0%")
        textoporc.grid(row=2 , column=0)
        
        global boton_detener_backup
        boton_detener_backup = ttk.Button(ventanaProgreso, text='Detener Copia',
         command=detener_backup, width=12)
        boton_detener_backup.grid(row=4, column=0, padx=30, pady=8, sticky=tk.S)
    else:
        ventanaProgreso = Toplevel(main_window)
        ventanaProgreso.title("Backup")
        ventanaProgreso.geometry(f'{"300"}x{"160"}+{int(90)}+{int(90)}')
        #ventanaProgreso.geometry("300x160")
        ventanaProgreso.minsize(300, 160)
        
        #global progressbar2
        progressbar2 = ttk.Progressbar(ventanaProgreso, mode="determinate", length=280)
        progressbar2.grid(row=1, sticky=tk.EW, pady=5, padx=10)
        progressbar2.step(0)
        
        #global texto
        texto = Label(ventanaProgreso, text="Backup is in progress")
        texto.grid(row=0, sticky=tk.EW, pady=10, padx=25)
        
        #global textoporc
        textoporc = Label(ventanaProgreso, text="Copied: 0%")
        textoporc.grid(row=2 , column=0)
        
        #global boton_detener_backup
        boton_detener_backup = ttk.Button(ventanaProgreso, text='Cancel Backup',
         command=detener_backup, width=12)
        boton_detener_backup.grid(row=4, column=0, padx=30, pady=8, sticky=tk.S)



#----------------------------------------------------------------------------------------
# Método que calcula el tamaño de la carpeta destino, actualizando la barra de progreso
#----------------------------------------------------------------------------------------
def calcular_tamanyo():
    print("Iniciamos calcular_tamnyo()")
    global control
    control = False
    size=0
    size2=0
    prog=0
    
    while control == False:
        
        try:
            
            size=0
            for ele in os.scandir(src):
                if ele.is_dir():
                    for dire in os.scandir(ele.path):
                        size+=os.path.getsize(dire.path)
                else:
                    size+=os.path.getsize(ele)
                    
            
            
            size2=0
            for ele in os.scandir(dst):
                if ele.is_dir():
                    for dire in os.scandir(ele.path):
                        size2+=os.path.getsize(dire.path)
                else:
                    size2+=os.path.getsize(ele)
                    
            
            prog = size2*100/size
            size2=0
            size=0
            progressbar2['value'] = prog
            
            
            if idioma=="Español":
                estado = "Copiado: " + str(round(prog)) + "%"
            else:
                estado = "Copied: " + str(round(prog)) + "%"
                
            textoporc.config(text=estado)
            
            if prog<99.99:
                size2=0
                
            
            else:
                print("el progreso es : "+ str(prog))
                prog=0
                control=True
                
                
                texto.config(text=backupRealizado)
                
                progressbar2['value']=0
                
                print(dst)
                del size
                del size2
                
                print("control es: "+str(control))
                
                print("---------------------\n")
                messagebox.showinfo(title=hecho, message=backupRealizado)
                ventanaProgreso.destroy()
                
                
        except:
            #print("No existe la carpeta todavía")
            1==1
        

background(actualizar_lista_auto)

#----------------------------------------------------------------------------------------
#Método que cambia el tema entre Claro/Oscuro
#----------------------------------------------------------------------------------------
def cambiar_tema():
    
    # NOTE: The theme's real name is azure-<mode>
    if main_window.tk.call("ttk::style", "theme", "use") == "azure-dark":
        # Set light theme
        main_window.tk.call("set_theme", "light")
    else:
        # Set dark theme
        main_window.tk.call("set_theme", "dark")
    

#----------------------------------------------------------------------------------------
# Método que comprueba si hay espacio disponible en el destino para copiar
# los archivos del origen en él
#----------------------------------------------------------------------------------------
def espacio_disponible():
    totalOrigen, usadoOrigen, disponibleOrigen = shutil.disk_usage(src)
    dest = "/media/"+str(user).rstrip("\n")+"/"+destino
    totalDestino, usadoDestino, disponibleDestino = shutil.disk_usage(dest)
    
    if usadoOrigen>disponibleDestino:
        return False
    else:
        return True
        
#----------------------------------------------------------------------------------------
#Método que abre una ventana con las instrucciones de uso      
#----------------------------------------------------------------------------------------
def instrucciones():
    ventanainfo = Toplevel(main_window)
    ventanainfo.title("Instrucciones")
    #ventanainfo.geometry(f'{"400"}x{"250"}+{int(90)}+{int(90)}')
    ventanainfo.geometry("400x260")
    ventanainfo.minsize(400, 260)
    if idioma=="Español":
        
        textfile = open("instrucciones.txt", 'r')
        message= textfile.read()
    else:
        ventanainfo.title("Instructions")
        textfile = open("instructions.txt", 'r')
        message= textfile.read()

    text_box = Text(
        ventanainfo,
        height=15,
        width=47
    )
    scroll_bar = tk.Scrollbar(ventanainfo, orient='vertical', command=text_box.yview)
    text_box['yscrollcommand'] = scroll_bar.set
    scroll_bar.grid(column=1, row=0, sticky=tk.NS)
    text_box.grid(column=0, row=0, sticky=tk.EW)
    text_box.insert('end', message)
    text_box.config(state='disabled')
    textfile.close()

#----------------------------------------------------------------------------------------
#Método que cambia el idioma entre Español e Inglés    
#----------------------------------------------------------------------------------------

def cambia_idioma(event):
    global idioma
    idioma=combo_idioma.get()
    cambiar_raiz()
    cambiar_idioma_mensajes()
    estadoOrigen.config(text="")
    estadoDestino.config(text="")
    #try:
    #    seleccion_origen(event)
    #    seleccion_destino(event)
    #except:
    #    True

    if idioma=="Español":
        combo_origen.set("Selecciona el origen")
        combo_destino.set("Seleciona el destino")
        boton_backup['text']= "Copiar"
        boton_expulsar_origen['text']="Expulsar "
        boton_expulsar_destino['text']="Expulsar "
        label_opciones_copia.config(text="Copiar desde: ")
        menu.entryconfigure(0, label="Cambiar tema")
        menu.entryconfigure(1, label="Mostrar temp CPU")
        menu.entryconfigure(2, label="Refrescar dispositivos")
        menu.entryconfigure(3, label="Reiniciar App")
        menu.entryconfigure(4, label="Minimizar")
        menu.entryconfigure(5, label="Reiniciar dispositivo")
        menu.entryconfigure(6, label="Apagar dispositivo")
        

    else:
        combo_origen.set("Select source")
        combo_destino.set("Select destination")
        boton_backup['text']= "Backup"
        boton_expulsar_origen['text']="Eject "
        boton_expulsar_destino['text']="Eject "
        label_opciones_copia.config(text="Copy from: ")
        menu.entryconfigure(0, label="Change theme")
        menu.entryconfigure(1, label="Show CPU temp")
        menu.entryconfigure(2, label="Refresh devices")
        menu.entryconfigure(3, label="Restart App")
        menu.entryconfigure(4, label="Minimize")
        menu.entryconfigure(5, label="Restart device")
        menu.entryconfigure(6, label="Shutdown device")
    
 
#----------------------------------------------------------------------------------------
#Método que cambia el idioma entre de la carepta raíz a root 
#----------------------------------------------------------------------------------------       
def cambiar_raiz():
    if idioma=="Español":
        opciones_copia = ["DCIM", "Raíz"]
        combo_copia['value']=opciones_copia
        
    else:
        opciones_copia = ["DCIM", "Root"]
        combo_copia['value']=opciones_copia
    
    

#----------------------------------------------------------------------------------------
#Método que muestra la temperatura de la cpu 
#----------------------------------------------------------------------------------------
def get_temperatura():
    
    while True:
        orig_color = label_opciones_copia.cget("foreground")
        global stop_temp
        if stop_temp:
            label_temp.config(text="")
            break
        else:
            temp=os.popen("vcgencmd measure_temp | egrep -o '[0-9]*\.[0-9]*'").read()
            temp=temp.rstrip("\n")
            t= "CPU temp = "+temp+"ºC"
            if float(temp)>67:
                label_temp.config(foreground="red")
            else:
                label_temp.config(foreground=orig_color)
            label_temp.config(text=t)
            time.sleep(1)

#----------------------------------------------------------------------------------------
#Método que activa o desactiva mostrar la temperatura
#----------------------------------------------------------------------------------------
def act_des_temp():
    global stop_temp
    if stop_temp:
        stop_temp=False
    else:
        stop_temp=True
    background(get_temperatura)

#----------------------------------------------------------------------------------------
#Método que muestra los hilos activos
#----------------------------------------------------------------------------------------
def threads():
    for thread in threading.enumerate(): 
        print(thread.name)

#----------------------------------------------------------------------------------------
#Método para hacer pruebas rápidas
#----------------------------------------------------------------------------------------
def prueba():
    
    print("src es: " +src)
    
    print("tipo copia es: "+seleccion_tipo_copia(exit))



#----------------------------------------------------------------------------------------
#Método que cambia el idioma de variables
#----------------------------------------------------------------------------------------
def cambiar_idioma_mensajes():
    if idioma == "Español":
        seleccionarPrimeroOrigen="Debe seleccionar primero el origen"
        usadoEn="Usado en "
        libre=" Libre: "
        Error="Error"
        noHayOrigen="No hay ningun origen seleccionado"
        noHayDestino="No hay ningun destino seleccionado"
        cancelado="Cancelado"
        seHaCancelado="Se ha detenido el Backup"
        noHayEspacio="No hay espacio suficiente en el destino"
        noHayDCIM="No existe DCIM en el origen"
        mismoOrigenDestino="El origen y el destino no pueden ser el mismo"
        esperaCopia="Espera a que termine la primera copia"
        haIdoMal="Algo ha ido mal con el backup"
        noDispositivo="No hay dispositivo"
        expulsado="El dispositivo se ha expulsado"
        reiniciarTitle="Reiniciar"
        reiniciar="Está seguro que quiere reiniciar?"
        apagarTitle="Apagar"
        apagar="¿Está seguro que quiere apagar?"
        backupRealizado="Se ha realizado el backup"
        hecho="Hecho"
        

    else:
        seleccionarPrimeroOrigen="You must first select a source"
        usadoEn="Used in "
        libre=" Free: "   
        noHayOrigen="No source selected"
        noHayDestino="No destination selected"
        cancelado="Cancelled"
        seHaCancelado="Backup has been stopped"
        noHayEspacio="Not enough space at destination"
        noHayDCIM="DCIM doesn't exist at source"
        mismoOrigenDestino="Source and destination cannot be the same"
        esperaCopia="Wait for the first backup to finish"
        haIdoMal="Something has gone wrong with the backup"
        noDispositivo="No device"
        expulsado="The device has been ejected"
        reiniciarTitle="Restart"
        reiniciar="Are you sure you want to restart?"
        apagarTitle="Shurdown"
        apagar="Are you sure you want to shutdown?"
        backupRealizado="The backup has been completed"
        hecho="Done"
    globals().update(locals())




#----------------------------------------------------------------------------------------
#-------------- SE DEFINEN LOS DIFERENTES ELEMENTOS -------------------------------------
#----------------------------------------------------------------------------------------


#----------------------------------------------------------------------------------------
# Se define la pantalla principal
#----------------------------------------------------------------------------------------
main_window = tk.Tk()
main_window.config(width=480, height=320)
main_window.minsize(480, 320)
main_window.title("Denislav Popov - TFG")
main_window.tk.call("source", "azure.tcl")
main_window.tk.call("set_theme", "dark")
main_window.attributes('-fullscreen', True)

#----------------------------------------------------------------------------------------
# Define un marco para los botones inferiores
#----------------------------------------------------------------------------------------
frame1 = Frame(main_window, width=470, height=40, highlightbackground="#5D5D5D",
 highlightthickness=2,)
#frame1.place(x=5, y=275)
frame1.grid(row=4, column=0, columnspan=3, pady=0)

#----------------------------------------------------------------------------------------
# Define un marco para "Copiar desde:"
#----------------------------------------------------------------------------------------
frame2 = Frame(main_window, width=180, height=40, highlightbackground="#5D5D5D",
 highlightthickness=2)
frame2.grid(row=2, column=0, padx=10)

#----------------------------------------------------------------------------------------
# Define el combobox para elegir el origen
#----------------------------------------------------------------------------------------
SelOrigen = StringVar(value='Selecciona el origen') 
combo_origen = ttk.Combobox(values=lista, state="readonly", font="Arial 11",
 textvariable=SelOrigen) 
combo_origen.bind("<<ComboboxSelected>>", seleccion_origen)
#combo.place(x=50, y=50)
combo_origen.grid(padx=10, pady=20, row=0, column=0)

#----------------------------------------------------------------------------------------
# Define el combobox para elegir el destino
#----------------------------------------------------------------------------------------
SelDestino = StringVar(value='Selecciona el destino')
combo_destino = ttk.Combobox(values=lista,state="readonly", font="Arial 11",
 textvariable=SelDestino)
combo_destino.bind("<<ComboboxSelected>>", seleccion_destino)
#combo2.place(x=50, y=100)
combo_destino.grid(row=1, column=0, pady=20)

#----------------------------------------------------------------------------------------
# Define el boton para hacer el backup
#----------------------------------------------------------------------------------------
boton_backup =ttk.Button(main_window, text='Copiar', style='Accent.TButton',
 command=lambda: background(botoncopia), width=12)
boton_backup.grid(row=0, column=2, padx=30, sticky=tk.W)

#----------------------------------------------------------------------------------------
# Define un botón para actualizar la lista. NO SE USA
#----------------------------------------------------------------------------------------
'''
boton_actualizar_lista =ttk.Button(main_window, text='Actualizar dispositivos',
 command=actualizar_lista)
boton_actualizar_lista.grid(row=2, column=0, pady=10)
'''

#----------------------------------------------------------------------------------------
# Icono de expulsar
#----------------------------------------------------------------------------------------
imagen_expulsar = PhotoImage(file = r"./res/eject.png")
expulsarr = imagen_expulsar.subsample(6,6)

#----------------------------------------------------------------------------------------
# Define el botón para expulsar el origen
#----------------------------------------------------------------------------------------
boton_expulsar_origen =ttk.Button(main_window, text='Expulsar ', image=expulsarr,
 compound=RIGHT, command=comando_expulsar_origen, width=8)
boton_expulsar_origen.grid(row=0, column=1, pady=10)

#----------------------------------------------------------------------------------------
# Define el botón para expulsar el destino
#----------------------------------------------------------------------------------------
boton_expulsar_destino =ttk.Button(main_window, text='Expulsar ', image=expulsarr,
 compound=RIGHT, command=comando_expulsar_destino, width=8)
boton_expulsar_destino.grid(row=1, column=1, pady=10)

#----------------------------------------------------------------------------------------
# Texto
#----------------------------------------------------------------------------------------
#label2 = Label( main_window, text = "TFG Denislav Miroslavov Popov @2021-2022", font=2,
#  fg = "#2b2b2b") 
#label2.grid(row=4, column=0, columnspan=3, pady=150, sticky=tk.S)

#----------------------------------------------------------------------------------------
# Define texto que muestra estado del origen
#----------------------------------------------------------------------------------------
estadoOrigen = Label(main_window, text="" , font=("Helvetica", 8))
estadoOrigen.grid(row=0 , column=0 , padx=5 ,pady=0, sticky=tk.S)

#----------------------------------------------------------------------------------------
# Define texto que muestra estado del destino
#----------------------------------------------------------------------------------------
estadoDestino = Label(main_window, text="" , font=("Helvetica", 8))
estadoDestino.grid(row=1 , column=0 , padx=5, pady=0, sticky=tk.S)

'''
#----------------------------------------------------------------------------------------
# Define el botón para reiniciar la app
#----------------------------------------------------------------------------------------
s = ttk.Style()
s.configure('estilo.TButton', font=('Helvetica', 8))
boton_reiniciar_app =ttk.Button(main_window, text='Reiniciar App', style='estilo.TButton',
 command=reiniciar_app, width=15)
boton_reiniciar_app.grid(row=3, column=2, pady=20)
#----------------------------------------------------------------------------------------
# Define el botón para reiniciar el dispositivo
#----------------------------------------------------------------------------------------
boton_reiniciar_disp =ttk.Button(main_window, text='Reiniciar Dispositivo',
 style='estilo.TButton', command=reiniciar_dispositivo, width=16)
boton_reiniciar_disp.grid(row=4, column=1, pady=20, sticky=tk.N)
#----------------------------------------------------------------------------------------
# Define el botón para apagar el dispositivo
#----------------------------------------------------------------------------------------
boton_apagar_disp =ttk.Button(main_window, text='Apagar Dispositivo',
 style='estilo.TButton', command=apagar_dispositivo, width=15)
boton_apagar_disp.grid(row=4, column=2, pady=20)
'''

'''
#----------------------------------------------------------------------------------------
# Define botón para quitar la pantalla completa de la app
#----------------------------------------------------------------------------------------
mins = ttk.Style()
mins.configure('mins.TButton', font=('Helvetica', 5), bg='black')
mins.map('mins.TButton', background=[('active', '#343434')])
boton_minimizar =ttk.Button(main_window, text='-', style='mins.TButton',
 command=minimizar, width=1)
boton_minimizar.grid(row=4, column=0,padx=12, pady=80, sticky=SW)
'''
#----------------------------------------------------------------------------------------
# Define el switch para encender/apagar el punto de acceso wifi
#----------------------------------------------------------------------------------------
var = tk.StringVar()
switch = ttk.Checkbutton(main_window, text='AP Wifi', style='Switch.TCheckbutton',
 variable=var, onvalue='start', offvalue='stop', command=wifi)
switch.grid(column=1, row=4, pady=80, sticky=tk.S)

#----------------------------------------------------------------------------------------
# Icono de "ajustes"
#----------------------------------------------------------------------------------------
imagen_opciones = PhotoImage(file = r"./res/settings.png")
opci = imagen_opciones.subsample(55,55)

#----------------------------------------------------------------------------------------
# Define el menú de opciones
#----------------------------------------------------------------------------------------
menu_opciones = ttk.Menubutton(main_window, text='Opciones', direction='above', image=opci)
menu = tk.Menu(menu_opciones, tearoff=False)
menu_opciones["menu"] = menu
menu_opciones.grid(row=4 , column=2,pady=80, padx=15, sticky=tk.SE)
Rapp = IntVar()
Rdisp = IntVar()
Adisp = IntVar()
ADispositivos = IntVar()
CTema = IntVar()
Minvar = IntVar()
TempVar = IntVar()

menu.add_checkbutton(label="Cambiar tema", variable=Adisp , command=cambiar_tema)
menu.add_checkbutton(label="Mostrar temp CPU", variable=TempVar , command=act_des_temp)
menu.add_checkbutton(label="Refrescar dispositivos", variable=Adisp ,
 command=actualizar_lista)
menu.add_checkbutton(label="Reiniciar App", variable= Rapp, command=reiniciar_app)
menu.add_checkbutton(label="Minimizar", variable=Minvar , command=minimizar)
menu.add_checkbutton(label="Reiniciar dispositivo", variable= Rdisp,
 command=reiniciar_dispositivo)
menu.add_checkbutton(label="Apagar dispositivo", variable=Adisp ,
 command=apagar_dispositivo)

#----------------------------------------------------------------------------------------
# Texto de "Copiar desde:"
#----------------------------------------------------------------------------------------
label_opciones_copia = Label(main_window, text="Copiar desde: " , font=("Helvetica", 10))
label_opciones_copia.grid(row=2 , column=0, padx=20 , pady=10, sticky=tk.W)
#check_frame = ttk.LabelFrame(main_window, text="", padding=(20, 20))
#check_frame.grid(row=2, rowspan=2, column=0, padx=(20, 10), pady=(0, 20), sticky="nsew")

#----------------------------------------------------------------------------------------
# Define un desplegable para elegir entre la carpeta DCIM y la raíz
#----------------------------------------------------------------------------------------
SelOpcion = StringVar(value='') 
opciones_copia = ["DCIM", "Raíz"]
combo_copia = ttk.Combobox(values=opciones_copia, state="readonly", font="Arial 7",
 textvariable=SelOpcion, width=10) 
combo_copia.bind("<<ComboboxSelected>>", seleccion_tipo_copia)
combo_copia.current(0)
#combo.place(x=50, y=50)
combo_copia.grid(padx=25, pady=10, row=2, column=0, sticky=tk.E)


#----------------------------------------------------------------------------------------
# Define un desplegable para elegir entre idioma Español e Inglés
#----------------------------------------------------------------------------------------
SelOp = StringVar(value='') 
opcioness = ["Español", "English"]
combo_idioma = ttk.Combobox(values=opcioness, state="readonly", font="Arial 7",
 textvariable=SelOp, width=10) 
combo_idioma.bind("<<ComboboxSelected>>", cambia_idioma)
combo_idioma.current(0)
#combo.place(x=50, y=50)
combo_idioma.grid(padx=26, pady=10, row=4, column=2, sticky=tk.W)

#----------------------------------------------------------------------------------------
# Icono 'info'
#----------------------------------------------------------------------------------------
imagen_i = PhotoImage(file = r"./res/boton_i.png")
i = imagen_i.subsample(45,45)

#----------------------------------------------------------------------------------------
# Botón para abrir las instrucciones
#----------------------------------------------------------------------------------------
boton_info =Button(main_window, text='',image = i, command=instrucciones, borderwidth=0)
boton_info.grid(row=4, column=0, pady=10, padx=20, sticky=tk.W)

'''#----------------------------------------------------------------------------------------
boton_prueba =ttk.Button(main_window, text='prueba', command=prueba)
boton_prueba.grid(row=3, column=1, pady=10)'''

#----------------------------------------------------------------------------------------
# Texto que muestra la temperatura de la cpu  
#----------------------------------------------------------------------------------------
label_temp = Label(main_window, text="" , font=("Helvetica", 8), borderwidth=0)
label_temp.config(anchor=CENTER)
orig_color = label_temp.cget("foreground")
label_temp.grid(row=4 , column=0, padx=20 , pady=0, sticky=tk.E)

#background(get_temperatura)

#----------------------------------------------------------------------------------------
#Método que apaga el wifi una vez cargada toda la app.
# Se apaga al final para tener disponible el punto de acceso en caso de fallo en
# la carga de la app
#----------------------------------------------------------------------------------------
def apagarwifi():
    os.system("sudo systemctl stop hostapd")
    
apagarwifi()

main_window.mainloop()
